/*____________________________________________________________________________
	
	Zinf - Zinf Is Not FreeA*p (The Free MP3 Player)

	Portions Copyright (C) 1998-1999 EMusic.com

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
	
	$Id: preferences.h,v 1.8 2003/01/11 02:22:13 kgk Exp $
____________________________________________________________________________*/

#ifndef INCLUDED_PREFERENCES_H
#define INCLUDED_PREFERENCES_H

#include <string>
#include "config.h"
#include "errors.h"

using namespace std;
// preferences
ZINF_EXPORT extern const char* kInstallDirPref;
ZINF_EXPORT extern const char* kLibraryPathPref;
ZINF_EXPORT extern const char* kUIPref;
ZINF_EXPORT extern const char* kTextUIPref;
ZINF_EXPORT extern const char* kMusicBrowserUIPref;
ZINF_EXPORT extern const char* kDownloadManagerUIPref;
ZINF_EXPORT extern const char* kToolbarUIPref;
ZINF_EXPORT extern const char* kSecondaryUIPref;
ZINF_EXPORT extern const char* kPMOPref;
ZINF_EXPORT extern const char* kALSADevicePref;
ZINF_EXPORT extern const char* kESOUNDHostPref;
ZINF_EXPORT extern const char* kOpenSaveDirPref;
ZINF_EXPORT extern const char* kStayOnTopPref;
ZINF_EXPORT extern const char* kLiveInTrayPref;
ZINF_EXPORT extern const char* kInputBufferSizePref;
ZINF_EXPORT extern const char* kOutputBufferSizePref;
ZINF_EXPORT extern const char* kStreamBufferIntervalPref;
ZINF_EXPORT extern const char* kDecoderThreadPriorityPref;
ZINF_EXPORT extern const char* kUseDebugLogPref;
ZINF_EXPORT extern const char* kLogMainPref;
ZINF_EXPORT extern const char* kLogDecodePref;
ZINF_EXPORT extern const char* kLogInputPref;
ZINF_EXPORT extern const char* kLogOutputPref;
ZINF_EXPORT extern const char* kLogPerformancePref;
ZINF_EXPORT extern const char* kSaveStreamsPref;
ZINF_EXPORT extern const char* kSaveStreamsDirPref;
ZINF_EXPORT extern const char* kUseProxyPref;
ZINF_EXPORT extern const char* kProxyHostPref;
ZINF_EXPORT extern const char* kPreBufferPref;
ZINF_EXPORT extern const char* kUseAlternateNICPref;
ZINF_EXPORT extern const char* kAlternateNICAddressPref;
ZINF_EXPORT extern const char* kUseTitleStreamingPref;  
ZINF_EXPORT extern const char* kThemePathPref;
ZINF_EXPORT extern const char* kMainWindowPosPref;
ZINF_EXPORT extern const char* kWindowModePref;
ZINF_EXPORT extern const char* kThemeDefaultFontPref;
ZINF_EXPORT extern const char* kSaveMusicDirPref;
ZINF_EXPORT extern const char* kDatabaseDirPref;
ZINF_EXPORT extern const char* kCheckForUpdatesPref;
ZINF_EXPORT extern const char* kPlaylistRepeatPref;
ZINF_EXPORT extern const char* kPlaylistShufflePref;
ZINF_EXPORT extern const char* kTimeDisplayPref;
ZINF_EXPORT extern const char* kVolumePref;
ZINF_EXPORT extern const char* kSoftMixerPref;
ZINF_EXPORT extern const char* kUserNamePref;
ZINF_EXPORT extern const char* kReclaimFiletypesPref;
ZINF_EXPORT extern const char* kAskToReclaimFiletypesPref;
ZINF_EXPORT extern const char* kUsersPortablePlayersPref;
ZINF_EXPORT extern const char* kShowToolbarTextLabelsPref;
ZINF_EXPORT extern const char* kShowToolbarImagesPref;
ZINF_EXPORT extern const char* kSaveCurrentPlaylistOnExitPref;
ZINF_EXPORT extern const char* kViewMusicBrowserPref;
ZINF_EXPORT extern const char* kWelcomePref;
ZINF_EXPORT extern const char* kPlayImmediatelyPref;
ZINF_EXPORT extern const char* kSetLastResumePref;
ZINF_EXPORT extern const char* kLastDirPref;
ZINF_EXPORT extern const char* kNumberOfURLsToRememberPref;
ZINF_EXPORT extern const char* kCDDevicePathPref;
ZINF_EXPORT extern const char* kCheckCDAutomaticallyPref;
ZINF_EXPORT extern const char* kMBServerPref;
ZINF_EXPORT extern const char* kConvertUnderscoresToSpacesPref;
ZINF_EXPORT extern const char* kAllowMultipleInstancesPref;
ZINF_EXPORT extern const char* kAudioCDLengthPref;
ZINF_EXPORT extern const char* kWatchThisDirectoryPref;
ZINF_EXPORT extern const char* kWatchThisDirTimeoutPref;
ZINF_EXPORT extern const char* kWriteID3v1Pref;
ZINF_EXPORT extern const char* kWriteID3v2Pref;
ZINF_EXPORT extern const char* kEqualizerSettingsPref;
ZINF_EXPORT extern const char* kSavedPlaylistPositionPref;
ZINF_EXPORT extern const char* kMusicBrowserPositionPref;
ZINF_EXPORT extern const char* kMusicBrowserHeaderWidthsPref;
ZINF_EXPORT extern const char* kCloseDLMOnCompletePref;
ZINF_EXPORT extern const char* kPerformDBCheckPref;
ZINF_EXPORT extern const char* kPlaylistHeaderColumnsPref;
ZINF_EXPORT extern const char* kAdvancedRelatablePref;
ZINF_EXPORT extern const char* kMetadataDisplayPref;
ZINF_EXPORT extern const char* kEnableMusicBrainzPref;
ZINF_EXPORT extern const char* kEnableBitziPref;
ZINF_EXPORT extern const char* kLastZinfVersionPref;
ZINF_EXPORT extern const char* kBrowser;
ZINF_EXPORT extern const char* kWriteVorbisTags;
 
ZINF_EXPORT extern const int32 kDefaultWatchThisDirTimeout;

class LibDirFindHandle;

class Preferences {
  public:
    virtual ~Preferences() { }

    virtual Error SetDefaults();
    virtual Error Save() = 0;

    virtual Preferences *ComponentPrefs(const char *componentName) = 0;

    // foundation preference functions
    virtual Error GetPrefString(const string&pref, string&buffer) = 0;
    virtual Error SetPrefString(const string& pref, const string& buf) = 0;

    virtual Error GetPrefBoolean(const string& pref, bool& value);
    virtual Error SetPrefBoolean(const string& pref, bool value);

    virtual Error GetPrefInt32(const string& pref, int32& value);
    virtual Error SetPrefInt32(const string& pref, int32 value);
 
    // <Deprecated>
    virtual Error GetPrefString(const char* pref, char* buf, uint32* len) = 0;
    virtual Error SetPrefString(const char* pref, const char* buf) = 0;

    virtual Error GetPrefBoolean(const char* pref, bool* value);
    virtual Error SetPrefBoolean(const char* pref, bool value);

    virtual Error GetPrefInt32(const char* pref, int32* value);
    virtual Error SetPrefInt32(const char* pref, int32 value);
    // </Deprecated>


    // Iterators for the zinf library path
    virtual LibDirFindHandle *GetFirstLibDir(char *path, uint32 *len);
    virtual Error GetNextLibDir(LibDirFindHandle *hLibDirFind,
				char *path, uint32 *len);
    virtual Error GetLibDirClose(LibDirFindHandle *hLibDirFind);

    // XXX: This is a non-portable hack, and should only be used for user
    //      messages.  Normally, you should use the iterators above instead.
    virtual const char *GetLibDirs() = 0;    
};

#endif /* _PREFERENCES_H */
